(function ()
{
  function done_event(data)
  {
    var myEvent = new CustomEvent('socmoduledone',{detail:{data:data}});
    document.dispatchEvent(myEvent);
  }

  function GetUser()
  {
    var profile_link = document.getElementById('myprofile');
    profile_link = profile_link.href.split('/');
    profile_link = profile_link[profile_link.length-1];
    return profile_link;
  }

  if(!window.ajax || !window.ajax.plainpost) return;
  var p = window.ajax.plainpost;
  window.ajax.plainpost = function(url, query, done, fail, urlonly)
  {
    var d = done;
    done = function(responseText,r)
    {
      // join
      if( (query.act == 'a_enter' && responseText.indexOf(GetUser())!=-1) || (query.act == 'enter' && responseText.indexOf('Groups.leave')!=-1) || (query.act == 'enter' && responseText.indexOf('_undecided') != -1) || (query.act == 'add' && responseText.indexOf('Profile.submitReqText') != -1))
      {
        if(query.context != '_undecided')
        {
          done_event({user:GetUser(),type:'join',post:window.location.pathname.substring(1)});
        }
      }
      // like
      else if(query.act == 'a_do_like')
      {    
        if(responseText.split('<!json>')[1])
        var count = JSON.parse(responseText.split('<!json>')[1]).like_num;
        else
        var count = responseText.match(/<!int[^>]*>([\s\S]*?)<!>/)[1];
        done_event({user:GetUser(),type:'like',post:query.object.replace('wall',''),count:count});
      }
      // share
      else if(query.act == 'a_do_publish' || responseText.indexOf('"share_my":1')!=-1)
      {
        var post = query.object.replace('wall','').replace('photo','');
        done_event({user:GetUser(),type:'share',post:post});
      }
      // share community
      else if(query.act == 'a_share' || query.act == 'share')
      {
        done_event({user:GetUser(),type:'sharecomm',post:window.location.href.replace(/https?:\/\//i,'')});
      }
      // share URL
      else if(query.act == 'a_submit' && responseText.indexOf('owner_id') != -1)
      {
        var resp = JSON.parse(responseText.split('<!json>')[1]);
        var post = resp.owner_id+'_'+resp.status_id;
        done_event({user:'id'+resp.owner_id,type:'shareurl',post:post});
      }
      d(responseText,r);
    }
    p(url, query, done, fail, urlonly);
  }
})();
